﻿Public Class main

    Private Sub Label1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub Label2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label2.Click
    End Sub

    Private Sub Label1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label1.Click

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        varName.Text = "state1"
        varInc.Text = "5"
        endingCommand.Text = "disable"
        helloBox.Checked = True

    End Sub

    Private Sub TextBox2_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles varName.TextChanged

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles genButton.Click
        generateScript(0, 0, 0)
    End Sub

    Private Sub ToolStripLabel1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub ToolStripContainer1_ContentPanel_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContentPanel.Load

    End Sub

    Private Sub ToolStripLabel1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub generatedScript_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles helloBox.CheckedChanged

    End Sub

    Private Sub endingCommand_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles endingCommand.TextChanged

    End Sub

    Private Sub copyButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles copyButton.Click
        Clipboard.SetDataObject(generatedScript.Text, True)
    End Sub

    Private Sub ClearAllToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearAllToolStripMenuItem.Click
        varName.Text = String.Empty
        varInc.Text = String.Empty
        helloBox.Checked = False
        endingCommand.Text = String.Empty
        waypoints.Text = String.Empty
        generatedScript.Text = String.Empty
    End Sub

    Private Sub CopyToClipboardToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyToClipboardToolStripMenuItem.Click
        Clipboard.SetDataObject(generatedScript.Text, True)
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        AboutBox1.Show()
    End Sub

    Private Sub GenerateToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GenerateToolStripMenuItem.Click
        GenerateSimilar()
    End Sub

    Private Sub generateScript(ByVal xchange As Integer, ByVal ychange As Integer, ByVal zchange As Integer)
        Dim isError As Boolean
        Dim errorFrom As String = "The following error(s) occurred: " & Environment.NewLine
        If varName.Text = "" Then
            isError = True
            errorFrom += "Variable name must not be blank" & Environment.NewLine
        End If
        If varInc.Text = "" Then
            isError = True
            errorFrom += "Increment must not be blank" & Environment.NewLine
        End If
        If waypoints.Text = "" Then
            isError = True
            errorFrom += "Must have at least one waypoint" & Environment.NewLine
        End If
        If isError = True Then
            MessageBox.Show(errorFrom, "ERROR")
        Else 'Actual script generating code below
            Dim counter As Integer = 0
            Dim currentVal As Integer = 0
            Dim runOnce As Boolean = True
            Dim waypt() As String = Split(waypoints.Text, Environment.NewLine)
            generatedScript.Text = "; Script generated by MW-WalkGen by Douglas Whitaker" & (Environment.NewLine)
            generatedScript.Text += "; http://www.douglaswhitaker.com/mw-tools/" & (Environment.NewLine)
            generatedScript.Text += "short " & varName.Text & (Environment.NewLine)
            While counter < waypt.Length
                If runOnce = True Then
                    generatedScript.Text += "if (" & varName.Text & " == " & (currentVal) & ")" & (Environment.NewLine)
                    If helloBox.Checked = True Then
                        generatedScript.Text += "sethello 0" & (Environment.NewLine)
                    End If
                Else
                    generatedScript.Text += "elseif (" & varName.Text & " == " & (currentVal) & ")" & (Environment.NewLine)
                End If
                generatedScript.Text += "AITravel "
                Dim coords As String() = Nothing
                coords = waypt(counter).Split(",")
                If (Not IsNumeric(coords(0)) Or Not IsNumeric(coords(1)) Or Not IsNumeric(coords(2))) Then
                    generatedScript.Text += waypt(counter) & (Environment.NewLine)
                Else
                    coords(0) = CStr(CDbl(coords(0) + xchange))
                    coords(1) = CStr(CDbl(coords(1) + ychange))
                    coords(2) = CStr(CDbl(coords(2) + zchange))
                    Dim coordprint As String
                    coordprint = coords(0) & ", " & coords(1) & ", " & coords(2)
                    generatedScript.Text += coordprint & (Environment.NewLine)
                End If
                currentVal += Val(varInc.Text)
                runOnce = False
                generatedScript.Text += "set " & varName.Text & " to " & (currentVal) & (Environment.NewLine)
                generatedScript.Text += "elseif (" & varName.Text & " == " & (currentVal) & ")" & (Environment.NewLine)
                generatedScript.Text += "if (GetAIPackageDone == 1)" & (Environment.NewLine)
                currentVal += Val(varInc.Text)
                If counter = (waypt.Length - 1) Then
                    generatedScript.Text += endingCommand.Text & (Environment.NewLine)
                Else
                    generatedScript.Text += "set " & varName.Text & " to " & (currentVal) & (Environment.NewLine)
                End If
                counter += 1
                generatedScript.Text += "endif" & (Environment.NewLine)
            End While
            generatedScript.Text += "endif" & (Environment.NewLine)
            generatedScript.Text += "; end script generated by MW-WalkGen"
        End If

    End Sub

    Private Sub HelpToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HelpToolStripMenuItem1.Click
        HelpBox1.Show()
    End Sub

    Private Sub GenerateSimilar()
        Dim RandomClass As New Random()

        Dim dX As Integer
        Dim pX As Integer
        dX = RandomClass.Next(5, 50)
        pX = RandomClass.Next(1, 3)
        If (pX = 2) Then
            dX *= -1
        End If

        Dim dY As Integer
        Dim pY As Integer
        dY = RandomClass.Next(5, 50)
        pY = RandomClass.Next(1, 3)
        If (pY = 2) Then
            dY *= -1
        End If

        Dim dZ As Integer
        Dim pZ As Integer
        dZ = RandomClass.Next(1, 15)
        pZ = RandomClass.Next(1, 3)
        If (pZ = 2) Then
            dZ *= -1
        End If

        generateScript(dX, dY, dZ)
    End Sub

    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        GenerateSimilar()
    End Sub

End Class
